/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AssertTaxaCount.java,v c51661255093 2010/08/17 18:40:13 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android.test.functional;

import javax.annotation.Nonnull;
import java.util.concurrent.Callable;
import it.tidalwave.semantic.AsSupport;
import android.test.ActivityInstrumentationTestCase2;
import com.jayway.android.robotium.solo.Solo;
import it.tidalwave.bluebill.mobile.android.taxonomy.browser.TaxonomyBrowserActivityTestHelper;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class AssertTaxaCount extends AsSupport implements Callable<Void>
  {
    @Nonnull
    private final TaxonomyBrowserActivityTestHelper taxonomyBrowserActivity;

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public AssertTaxaCount (final @Nonnull ActivityInstrumentationTestCase2 instrumentationTestCase,
                            final @Nonnull Solo solo,
                            final @Nonnull Object ... capabilities)
      {
        super(capabilities);

        taxonomyBrowserActivity = new TaxonomyBrowserActivityTestHelper(instrumentationTestCase, solo);
      }

    public Void call()
      throws Exception
      {
        taxonomyBrowserActivity.assertTaxaCount(as(Integer.class));
        taxonomyBrowserActivity.assertTaxonomyLabel(as(String.class));

        return null;
      }
  }
