/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: GoToSpeciesBrowser.java,v f32689862d36 2010/08/17 19:14:05 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android.test.functional;

import javax.annotation.Nonnull;
import java.util.concurrent.Callable;
import it.tidalwave.semantic.AsSupport;
import it.tidalwave.bluebill.mobile.android.taxonomy.browser.TaxonPicker;
import it.tidalwave.bluebill.mobile.android.taxonomy.browser.PickTaxonActivityTestHelper;
import it.tidalwave.bluebill.mobile.android.taxonomy.browser.TaxonomyBrowserActivityTestHelper;
import it.tidalwave.bluebill.mobile.android.location.LocationPicker;
import it.tidalwave.bluebill.mobile.android.location.PickLocationActivityTestHelper;
import it.tidalwave.bluebill.mobile.android.observation.CountAndGenderPicker;
import it.tidalwave.bluebill.mobile.android.observation.CountAndGenderActivityHelper;
import it.tidalwave.bluebill.mobile.android.observation.ObservationActivityTestHelper;
import android.test.ActivityInstrumentationTestCase2;
import com.jayway.android.robotium.solo.Solo;
import it.tidalwave.util.AsException;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class GoToSpeciesBrowser extends AsSupport implements Callable<Void>
  {
    @Nonnull
    private final ObservationActivityTestHelper observationActivity;

    @Nonnull
    private final PickTaxonActivityTestHelper pickTaxonActivity;

    @Nonnull
    private final TaxonomyBrowserActivityTestHelper taxonomyBrowserActivity;

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public GoToSpeciesBrowser (final @Nonnull ActivityInstrumentationTestCase2 instrumentationTestCase,
                              final @Nonnull Solo solo,
                              final @Nonnull Object ... capabilities)
      {
        super(capabilities);

        observationActivity = new ObservationActivityTestHelper(instrumentationTestCase, solo);
        pickTaxonActivity = new PickTaxonActivityTestHelper(instrumentationTestCase, solo);
        taxonomyBrowserActivity = new TaxonomyBrowserActivityTestHelper(instrumentationTestCase, solo);
      }
    
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public Void call()
      throws Exception
      {
        observationActivity.waitForActivity();
        observationActivity.clickOnAddObservationButton();

        pickTaxonActivity.waitForActivity();
//        as(HistoricTaxaAsserter.class).assertHistoricTaxa(pickTaxonActivity);
        pickTaxonActivity.clickOnSpeciesButton();

        taxonomyBrowserActivity.waitForActivity();
        int timeout = 10000;

        try
          {
            timeout = as(Integer.class);
          }
        catch (AsException e)
          {
            // take the default
          }

        taxonomyBrowserActivity.waitForTaxaListNotEmpty(timeout);

        return null;
      }
  }
