/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: InsertTwoObservationsFromScratchTest.java,v bcf37bbdff9d 2010/08/17 18:04:46 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android.test.functional;

import java.util.Locale;
import static it.tidalwave.bluebill.mobile.android.taxonomy.browser.TaxonomyPicker.*;
import static it.tidalwave.bluebill.mobile.android.taxonomy.browser.TaxonPicker.*;
import static it.tidalwave.bluebill.mobile.android.observation.CountAndGenderPickerFactory.*;
import static it.tidalwave.bluebill.mobile.android.location.LocationPickerFactory.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class InsertTwoObservationsFromScratchTest extends ObservationScenarioTestSupport
  {
    protected void prepareSequence()
      {
        step(SetDefaultLocale.class,  new Locale("en", "gb"));
        step(ClearAllObservations.class);
        step(TaxonomyChangerFromObservationsActivity.class,   pickEbnItalia2003());
        step(InsertObservation.class, assertHistoricTaxaCount(8),
                                      pickTheLittleGrebe(),
                                      dontSpecifyCountAndGender(),
                                      confirmImmediatelyTheLocation());
        step(InsertObservation.class, assertHistoricTaxaCount(8 + 1),
                                      pickTheEurasianSpoonBill(),
                                      dontSpecifyCountAndGender(),
                                      confirmImmediatelyTheLocation());
      }

    protected void assertPostConditions()
      {
        observationActivity.assertHeaderText("2 observations");
        observationActivity.assertObservationCount(2);
        observationActivity.assertObservationItemCount(0, 1);
        observationActivity.assertObservationItemCount(1, 1);
        observationActivity.assertThatLastNodeIsExpandedOthersAreCollapsed();
        // TODO: assert screen contents, also properly sorted
      }
  }
